/*
  This file is part of SLC.
  Copyright (C) 2008 Sebastien LUTTRINGER <contact@seblu.net>

  SLC is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; version 2 of the License.

  SLC is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with SLC; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef CONNECTION_HH
# define CONNECTION_HH

class Connection {
public:
  Connection();


  bool connected() const;
  void start();
  void stop();
  void send(const string &data);
  void send(const char* buf, size_t len);
  void sendln(const string &data);
  void sendln(const char* buf, size_t len);
  string recvln();
private:
  void connect_(const char *addr, int port);
  void disconnect_();
private:
  int socket_;
  string rbuf_;
};

#endif
