/*
  This file is part of SLD.
  Copyright (C) 2008 Sebastien LUTTRINGER <contact@seblu.net>

  SLD is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; version 2 of the License.

  SLD is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with SLD; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef LOG_HH
# define LOG_HH

#include <ostream>
#include <fstream>

typedef std::string string;
typedef std::ostream ostream;
typedef std::ofstream ofstream;

class Logger {
public:
  Logger(ostream &o) : flux_(o) {}
  Logger(ostream &, const string &);
  ~Logger();

  bool file(const string &);
  bool has_file() const;

  friend Logger &operator<<(Logger &l, const string &s);
  friend Logger &operator<<(Logger &l, const char *s);
  friend Logger &operator<<(Logger &l, int i);

private:
  ostream &flux_;
  ofstream logfile_;

};

extern Logger logout;
extern Logger logerr;

#endif
