/*
  This file is part of SLD.
  Copyright (C) 2008 Sebastien LUTTRINGER <contact@seblu.net>

  SLD is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; version 2 of the License.

  SLD is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with SLD; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef OPTIONS_HH
# define OPTIONS_HH

# include "log.hh"

struct Options {
  Options();

  void merge(const Options &);
  Options &getoptions(int argc, char *argv[]);
  Options getoptions(const string file);
  void usage(const char *argv0) const;
  friend Logger &operator<<(Logger &, const Options &);


  string server;
  int port; //-1 undef
  string login;
  string pass;
  int verbose; //0=false, 1=true, -1=undef
  string scriptdir;
  string conffile;
  int retrydelay; //-1 undef
  int daemon;
  int closefd; //-1 undel
  string pidfile;
  string logfile;
};

#endif
