/*
  This file is part of SLS.
  Copyright (C) 2008 Sebastien LUTTRINGER <contact@seblu.net>

  SLS is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; version 2 of the License.

  SLS is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with SLS; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef OPTIONS_HH
# define OPTIONS_HH

struct Option {
  Option();

  Option &load(int argc, char *argv[]);
  Option &loadenv();

  void usage(const char *name, ostream &out) const;

  void print(ostream &s = std::cout) const;

  bool verbose;
  string database;

  // socket option
  int port;
  size_t maxconn;

  // daemon options
  bool daemon;
  string pidfile;
  string logfile;

};

#endif
